package com.loafle.overflow.agent.dao;

import com.loafle.overflow.agent.model.Agent;
import com.loafle.overflow.commons.dao.JPABaseDAO;
import com.loafle.overflow.member.model.Member;

import javax.persistence.Query;
import java.util.ArrayList;
import java.util.List;


/**
 * Created by insanity on 17. 5. 29.
 */
public class JPAAgentDAO extends JPABaseDAO<Agent> implements AgentDAO {

    public List<Agent> findAgentListByMemberId(Member member) {
        Query query = getEntityManager()
                .createNativeQuery("SELECT agt.* FROM AGENT agt WHERE agt.MEMBER_ID = :member", Agent.class);
        query.setParameter("member", member.getId());

        List<Agent> list = new ArrayList<>();
        try {
            list = query.getResultList();
        }catch(Exception e) {
            e.printStackTrace();
        }finally {
            return list;
        }
    }

}
