package com.loafle.overflow.crawler.dao;

import com.loafle.overflow.commons.dao.JPABaseDAO;
import com.loafle.overflow.crawler.model.Crawler;
import com.loafle.overflow.crawler.model.CrawlerInputItemMapping;

import javax.persistence.Query;
import java.util.List;

/**
 * Created by geek@loafle.com on 17. 6. 8.
 */
public class JPACrawlerInputItemMappingDAO extends JPABaseDAO<CrawlerInputItemMapping> implements CrawlerInputItemMappingDAO {
    @Override
    public List<CrawlerInputItemMapping> findByCrawlerId(Crawler crawler) {
        Query query = getEntityManager().createNativeQuery("SELECT m.* FROM CRAWLER_INPUT_ITEM_MAPPING m WHERE m.crawler_id = :crawler_id", CrawlerInputItemMapping.class);
        query.setParameter("crawler_id", crawler.getId());

        List<CrawlerInputItemMapping> crs = null;

        try {
            crs = (List<CrawlerInputItemMapping>)query.getResultList();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            return crs;
        }
    }
}
