package com.loafle.overflow.crawler.model;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

/**
 * Created by geek@loafle.com on 17. 6. 8.
 */
@SuppressWarnings("serial")
@Entity(name="CRAWLER_INPUT_ITEM_MAPPING")
public class CrawlerInputItemMapping implements Serializable {
    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    private Long id;

    @ManyToOne
    @JoinColumn(name = "CRAWLER_ID", nullable=false)
    private Crawler crawler;

    @ManyToOne
    @JoinColumn(name = "CRAWLER_INPUT_ITEM_ID", nullable=false)
    private CrawlerInputItem crawlerInputItem;

    @Column(name = "PRIORITY")
    private short priority;

    @Column(name = "REQUIRED_TYPE")
    private boolean requiredType;

    @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
    private Date createDate;

    public CrawlerInputItemMapping(){}
    public CrawlerInputItemMapping(Long id){
        this.id = id;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Crawler getCrawler() {
        return crawler;
    }

    public void setCrawler(Crawler crawler) {
        this.crawler = crawler;
    }

    public CrawlerInputItem getCrawlerInputItem() {
        return crawlerInputItem;
    }

    public void setCrawlerInputItem(CrawlerInputItem crawlerInputItem) {
        this.crawlerInputItem = crawlerInputItem;
    }

    public short getPriority() {
        return priority;
    }

    public void setPriority(short priority) {
        this.priority = priority;
    }

    public boolean isRequiredType() {
        return requiredType;
    }

    public void setRequiredType(boolean requiredType) {
        this.requiredType = requiredType;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }
}
