package com.loafle.overflow.email.dao;

import com.loafle.overflow.commons.dao.JPABaseDAO;
import com.loafle.overflow.email.model.EmailAuth;

import javax.persistence.Query;
import java.util.List;

/**
 * Created by geek@loafle.com on 17. 6. 6.
 */
public class JPAEmailAuthDAO extends JPABaseDAO<EmailAuth> implements EmailAuthDAO {

    public EmailAuth findByAuthToken(EmailAuth emailAuth) {
        Query query = getEntityManager().createNativeQuery("SELECT e.* FROM EMAIL_AUTH e WHERE e.auth_token = :auth_token", EmailAuth.class);
        query.setParameter("auth_token", emailAuth.getAuthToken());

        EmailAuth auth = null;

        try {
            auth = (EmailAuth)query.getSingleResult();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            return auth;
        }
    }

    @Override
    public List<EmailAuth> findByMemberId(EmailAuth emailAuth) {
        Query query = getEntityManager().createNativeQuery("SELECT e.* FROM EMAIL_AUTH e WHERE e.member_id = :member_id", EmailAuth.class);
        query.setParameter("member_id", emailAuth.getMember().getId());

        List<EmailAuth> auths = null;

        try {
            auths = (List<EmailAuth>)query.getResultList();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            return auths;
        }
    }

//    @Override
//    public EmailAuth updateEmailAuth(EmailAuth emailAuth) {
//        EntityTransaction tx = this.getEntityManager().getTransaction();
//        if (!tx.isActive()) {
//            tx.begin();
//        }
//
//        try {
//            emailAuth.setUpdateDate(new Date());
//
//            EmailAuth result = this.getEntityManager().merge(emailAuth);
//            tx.commit();
//            return result;
//        }catch (Exception e) {
//            tx.rollback();
//            return null;
//        }
//    }
}
