package com.loafle.overflow.noauthagent.dao;

import com.loafle.overflow.commons.dao.JPABaseDAO;
import com.loafle.overflow.noauthagent.model.NoAuthAgent;

import javax.persistence.Query;
import java.util.List;

/**
 * Created by root on 17. 5. 30.
 */
public class JPANoAuthAgentDAO extends JPABaseDAO<NoAuthAgent> implements NoAuthAgentDao {
    public NoAuthAgent findByTempKey(NoAuthAgent noAuthAgent) {
        Query query = getEntityManager().createNativeQuery("SELECT na.* FROM NOAUTH_AGENT na WHERE na.TEMP_KEY = :tempkey", NoAuthAgent.class);
        query.setParameter("tempkey", noAuthAgent.getTempKey());

        NoAuthAgent authAgent = null;
        try {
            authAgent = (NoAuthAgent)query.getSingleResult();
        }catch(Exception e) {
            e.printStackTrace();
        }finally {
            return authAgent;
        }
    }

    public List<NoAuthAgent> findAllByNoAuth(NoAuthAgent noAuthAgent) {

        Query query = getEntityManager().createNativeQuery("SELECT na.* FROM NOAUTH_AGENT na WHERE na.AUTH_STATUS != :authStatus", NoAuthAgent.class);
        query.setParameter("authStatus", noAuthAgent.getAuthStatus().toString());

        List<NoAuthAgent> authAgentList = null;
        try {
            authAgentList = (List<NoAuthAgent>)query.getResultList();
        }catch(Exception e) {
            e.printStackTrace();
        }finally {
            return authAgentList;
        }

    }
}
