package com.loafle.overflow.sensor.dao;

import com.loafle.overflow.agent.model.Agent;
import com.loafle.overflow.commons.dao.JPABaseDAO;
import com.loafle.overflow.sensor.model.Sensor;

import javax.persistence.Query;
import java.util.List;

/**
 * Created by root on 17. 6. 9.
 */
public class JPASensorDao extends JPABaseDAO<Sensor> implements SensorDao {

    public List<Sensor> findAllByAgentID(Agent agent) {
        Query query = getEntityManager().createNativeQuery("SELECT s.* FROM Sensor s WHERE s.TARGET_ID = :memberId", Sensor.class);
        query.setParameter("memberId", agent.getMember().getId());

        List<Sensor> sensors = null;
        try {
            sensors = (List<Sensor>)query.getResultList();
        }catch(Exception e) {
            e.printStackTrace();
        }finally {
            return sensors;
        }
    }
}
