package com.loafle.overflow.sensor.dao;

import com.loafle.overflow.commons.dao.JPABaseDAO;
import com.loafle.overflow.crawler.model.Crawler;
import com.loafle.overflow.sensor.model.SensorItem;


import javax.persistence.Query;
import java.util.List;

/**
 * Created by root on 17. 6. 9.
 */
public class JPASensorItemDao extends JPABaseDAO<SensorItem> implements SensorItemDao {

    public List<SensorItem> findAllByCrawlerID(Crawler crawler) {

        Query query = getEntityManager().createNativeQuery("SELECT si.* FROM SensorItem si WHERE si.CRAWLER_ID = :crawlerId", SensorItem.class);
        query.setParameter("crawlerId", crawler.getId());

        List<SensorItem> sensorItems = null;
        try {
            sensorItems = (List<SensorItem>)query.getResultList();
        }catch(Exception e) {
            e.printStackTrace();
        }finally {
            return sensorItems;
        }

    }
}
