package com.loafle.overflow.sensor.dao;

import com.loafle.overflow.commons.dao.JPABaseDAO;
import com.loafle.overflow.sensor.model.Sensor;
import com.loafle.overflow.sensor.model.SensorItemMapping;

import javax.persistence.Query;
import java.util.List;

/**
 * Created by root on 17. 6. 9.
 */
public class JPASensorItemMappingDao extends JPABaseDAO<SensorItemMapping> implements SensorItemMappingDao {

    public List<SensorItemMapping> findAllBySensorID(Sensor sensor) {

        Query query = getEntityManager().createNativeQuery("SELECT sim.* FROM SensorItemMapping sim WHERE sim.SENSOR_ID = :sensorId", SensorItemMapping.class);
        query.setParameter("sensorId", sensor.getId());

        List<SensorItemMapping> sensorItemMappings = null;
        try {
            sensorItemMappings = (List<SensorItemMapping>)query.getResultList();
        }catch(Exception e) {
            e.printStackTrace();
        }finally {
            return sensorItemMappings;
        }

    }
}
