package com.loafle.overflow.sensor.model;

import com.loafle.overflow.crawler.model.Crawler;
import com.loafle.overflow.target.model.Target;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 9.
 */
@Entity
public class Sensor {

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    private Long id;

    @Column(name = "INTERVAL")
    private long interval;

    @Column(name = "NOTIFICATION")
    private String notification;

    @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = true)
    private Date createDate;

    @ManyToOne
    @JoinColumn(name = "TARGET_ID", nullable = false)
    private Target target;

    @ManyToOne
    @JoinColumn(name = "CRAWLER_ID", nullable = false)
    private Crawler crawler;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public long getInterval() {
        return interval;
    }

    public void setInterval(long interval) {
        this.interval = interval;
    }

    public String getNotification() {
        return notification;
    }

    public void setNotification(String notification) {
        this.notification = notification;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public Target getTarget() {
        return target;
    }

    public void setTarget(Target target) {
        this.target = target;
    }

    public Crawler getCrawler() {
        return crawler;
    }

    public void setCrawler(Crawler crawler) {
        this.crawler = crawler;
    }
}
