package com.loafle.overflow.sensor.model;

import com.loafle.overflow.crawler.model.Crawler;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 9.
 */
@Entity
public class SensorItem {

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    private Long id;

    @Column(name="NAME", nullable=false)
    private String name;

    @Column(name="DESCRIPTION", nullable=false)
    private String description;

    @Column(name="DATA_TYPE",nullable=false)
    private String dataType;

    @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = true)
    private Date createDate;

    @ManyToOne
    @JoinColumn(name="CRAWLER_ID",nullable=false)
    private Crawler crawler;

    @ManyToOne
    @JoinColumn(name="SENSOR_ITEM_CATEGORY_ID",nullable=false)
    private SensorItemCategory sensorItemCategory;


    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDataType() {
        return dataType;
    }

    public void setDataType(String dataType) {
        this.dataType = dataType;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public Crawler getCrawler() {
        return crawler;
    }

    public void setCrawler(Crawler crawler) {
        this.crawler = crawler;
    }

    public SensorItemCategory getSensorItemCategory() {
        return sensorItemCategory;
    }

    public void setSensorItemCategory(SensorItemCategory sensorItemCategory) {
        this.sensorItemCategory = sensorItemCategory;
    }
}
